package com.loafle.overflow.module.discovery.service;

import com.loafle.overflow.commons.model.SessionMetadata;
import com.loafle.overflow.commons.service.MessagePublisher;
import com.loafle.overflow.commons.stereotype.ProbeAPI;
import com.loafle.overflow.commons.stereotype.WebappAPI;
import com.loafle.overflow.module.discovery.model.DiscoveryHost;
import com.loafle.overflow.module.discovery.model.DiscoveryPort;
import com.loafle.overflow.module.discovery.model.DiscoveryStartInfo;
import com.loafle.overflow.module.discovery.model.DiscoveryZone;
import com.loafle.overflow.module.discovery.model.Host;
import com.loafle.overflow.module.discovery.model.Port;
import com.loafle.overflow.module.discovery.model.Zone;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;

/**
 * Created by snoop on 17. 9. 28.
 */
@Service("DiscoveryService")
public class DiscoveryService {

    @Autowired
    private MessagePublisher messagePublisher;

    public void startDiscovery(DiscoveryStartInfo startInfo) throws IOException {

        ObjectMapper objectMapper = new ObjectMapper();

        String json = objectMapper.writeValueAsString(startInfo);

        System.out.println("Start Discovery");
        System.out.println(json);
//        this.messagePublisher.publishToProbe("/auth", noAuthProbe.getTempProbeKey(), "NoAuthProbeService.acceptNoAuthProbe", probe.getProbeKey());
    }

//     public boolean testDiscovery(int types, String obj) {

//         Domain domain = new Domain();
//         domain.setId(1);

// //        int typeInt = Integer.valueOf(types);
//         switch (types) {
//             case 1 :
//                 messagePublisher.publishToDomainMembers(domain, "DiscoveryService.discoveryIngHost", obj);
//                 break;
//             case 2 :
//                 messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngPort", obj);
//                 break;
//             case 3 :
//                 messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngService", obj);
//                 break;
//         }


//         return true;
// 		}
		
		@WebappAPI
		public void discoverZone(String probeID, DiscoveryZone discoveryZone) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverZone", requesterSessionID, discoveryZone);
		}
	
		@WebappAPI
		public void discoverHost(String probeID, Zone zone, DiscoveryHost discoveryHost) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverHost", requesterSessionID, zone, discoveryHost);
		}
	
		@WebappAPI
		public void discoverPort(String probeID, Host host, DiscoveryPort discoveryPort) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverPort", requesterSessionID, host, discoveryPort);
		}
	
		@WebappAPI
		public void discoverService(String probeID, Port port, com.loafle.overflow.module.discovery.model.DiscoveryService discoveryService) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverService", requesterSessionID, port, discoveryService);
		}
	
	
		@ProbeAPI
		public void discoveredZone(String requesterSessionID, Zone zone) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredZone", zone);			
		}
	
		@ProbeAPI
		public void discoveredHost(String requesterSessionID, Host host) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredHost", host);			
		}
	
		@ProbeAPI
		public void discoveredPort(String requesterSessionID, Port port) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredPort", port);			
		}
	
		@ProbeAPI
		public void discoveredService(String requesterSessionID, com.loafle.overflow.module.discovery.model.Service service) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredService", service);			
		}
	
}