package com.loafle.overflow.module.meta.model;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by snoop on 17. 8. 29.
 */
@Entity
@Table(name = "META_SENSOR_ITEM_KEY", schema = "public")
public class MetaSensorItemKey {
    private long id;
    private MetaSensorItem item;
    private String key;
    private String froms;
    private String option;
    private MetaCrawler crawler;
    private Date createDate;
    private MetaSensorItemUnit unit;

    public MetaSensorItemKey() {

    }

    public MetaSensorItemKey(long id) {
        this.id = id;
    }

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "ITEM_ID", nullable = false)
    public MetaSensorItem getItem() {
        return item;
    }

    public void setItem(MetaSensorItem item) {
        this.item = item;
    }

    @Column(name = "KEY", nullable = false, length = 100)
    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    @Column(name = "FROMS", nullable = false, length = 100)
    public String getFroms() {
        return froms;
    }

    public void setFroms(String froms) {
        this.froms = froms;
    }

    @Column(name = "OPTION_JSON", nullable = true)
    public String getOption() {
        return option;
    }

    public void setOption(String option) {
        this.option = option;
    }

    @ManyToOne
    @JoinColumn(name = "CRAWLER_ID", nullable = false)
    public MetaCrawler getCrawler() {
        return crawler;
    }

    public void setCrawler(MetaCrawler crawler) {
        this.crawler = crawler;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @ManyToOne
    @JoinColumn(name = "UNIT_ID", nullable = true)
    public MetaSensorItemUnit getUnit() {
        return unit;
    }

    public void setUnit(MetaSensorItemUnit unit) {
        this.unit = unit;
    }
}
