package com.loafle.overflow.module.probe.model;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.meta.model.MetaProbeStatus;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "PROBE", schema = "public")
public class Probe {

    private long id;
    private MetaProbeStatus status;
    private String description;
    private Date createDate;
    private Domain domain;
    private String probeKey;
    private String encryptionKey;
    private String displayName;
    private String cidr;
    private Date authorizeDate;
    private Member authorizeMember;

    private List<Infra> targets;

//    private InfraHost host;
//    private int targetCount;
//    private int sensorCount;

    public Probe() {

    }

    public Probe(long id) {
        this.id = id;
    }

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "STATUS", nullable = false)
    public MetaProbeStatus getStatus() {
        return status;
    }

    public void setStatus(MetaProbeStatus status) {
        this.status = status;
    }


    @Column(name = "DESCRIPTION", nullable = true, length = 50)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @ManyToOne
    @JoinColumn(name = "DOMAIN_ID", nullable = false)
    public Domain getDomain() {
        return domain;
    }

    public void setDomain(Domain domain) {
        this.domain = domain;
    }


    @Column(name = "PROBE_KEY", nullable = false, unique = true)
    public String getProbeKey() {
        return probeKey;
    }

    public void setProbeKey(String probeKey) {
        this.probeKey = probeKey;
    }


    @Column(name = "ENCRYPTION_KEY", nullable = false, length = 100, unique = true)
    public String getEncryptionKey() {
        return encryptionKey;
    }

    public void setEncryptionKey(String encryptionKey) {
        this.encryptionKey = encryptionKey;
    }


    @Transient
    public List<Infra> getTargets() {
        return targets;
    }

    public void setTargets(List<Infra> targets) {
        this.targets = targets;
    }

    //    @Column(name = "TARGET_COUNT", nullable = false)
//    public int getTargetCount() {
//        return targetCount;
//    }
//
//    public void setTargetCount(int targetCount) {
//        this.targetCount = targetCount;
//    }
//
//    @Column(name = "SENSOR_COUNT", nullable = false)
//    public int getSensorCount() {
//        return sensorCount;
//    }
//
//    public void setSensorCount(int sensorCount) {
//        this.sensorCount = sensorCount;
//    }

    @Column(name = "DISPLAY_NAME")
    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    @Column(name = "CIDR")
    public String getCidr() {
        return cidr;
    }

    public void setCidr(String cidr) {
        this.cidr = cidr;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "AUTHORIZE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getAuthorizeDate() {
        return authorizeDate;
    }

    public void setAuthorizeDate(Date authorizeDate) {
        this.authorizeDate = authorizeDate;
    }

    @ManyToOne
    @JoinColumn(name = "AUTHORIZE_MEMBER_ID", nullable = false)
    public Member getAuthorizeMember() {
        return authorizeMember;
    }

    public void setAuthorizeMember(Member authorizeMember) {
        this.authorizeMember = authorizeMember;
    }
//
//    @ManyToOne
//    @JoinColumn(name = "HOST_ID", nullable = false)
//    public InfraHost getHost() {
//        return host;
//    }
//
//    public void setHost(InfraHost host) {
//        this.host = host;
//    }
}
