package com.loafle.overflow.module.probe.service;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.infra.dao.InfraDAO;
import com.loafle.overflow.module.probe.dao.ProbeDAO;
import com.loafle.overflow.module.probe.model.Probe;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("ProbeService")
public class ProbeService {

    @Autowired
    private ProbeDAO probeDAO;
    @Autowired
    private InfraDAO infraDAO;

    public Probe regist(Probe probe) {
        return this.probeDAO.save(probe);
    }

    public List<Probe> regist(List<Probe> probes) {
        return this.probeDAO.save(probes);
    }

    public List<Probe> readAllByDomain(Domain domain) {
        List<Probe> probes = this.probeDAO.findAllByDomainOrderByIdDesc(domain);
        for(Probe probe : probes) {
            probe.setTargets(this.infraDAO.findAllByProbe(probe));
        }
        return probes;
    }

    public Probe read(long id) {
        Probe probe =  this.probeDAO.findOne(id);
        probe.setTargets(this.infraDAO.findAllByProbe(probe));
        return probe;
    }

    public Probe readByProbeKey(String probeKey) {

        return this.probeDAO.findByProbeKey(probeKey);
    }

    public Probe modify(Probe probe) {
        return this.probeDAO.save(probe);
    }
}
