package com.loafle.overflow.proxy;

import com.loafle.overflow.commons.model.SessionMetadata;
import io.grpc.*;

public class ProxyServerInterceptor implements ServerInterceptor {

    @Override
    public <ReqT, RespT> ServerCall.Listener<ReqT> interceptCall(ServerCall<ReqT, RespT> call, Metadata headers, ServerCallHandler<ReqT, RespT> next) {
        String clientType = headers.get(SessionMetadata.METADATA_CLIENT_TYPE_KEY);
        String sessionID = headers.get(SessionMetadata.METADATA_SESSION_ID_KEY);
        String targetID = headers.get(SessionMetadata.METADATA_TARGET_ID_KEY);

        Context ctx = Context.current().withValues(
            SessionMetadata.CTX_CLIENT_TYPE_KEY, clientType,
            SessionMetadata.CTX_SESSION_ID_KEY, sessionID,
            SessionMetadata.CTX_TARGET_ID_KEY, targetID
        );

        return Contexts.interceptCall(ctx, call, headers, next);
    }
}
