package com.loafle.overflow.module.auth.service;

import com.loafle.overflow.module.auth.model.AuthCrawler;
import com.loafle.overflow.module.meta.model.MetaCrawler;
import com.loafle.overflow.module.target.model.Target;
import com.loafle.overflow.spring.AppConfigTest;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 8. 30.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class AuthCrawlerServiceTest {

    @Autowired
    private AuthCrawlerService authCrawlerService;

    @Test
    public void regist() throws Exception {

        AuthCrawler authCrawler = new AuthCrawler();

        Target target = new Target();
        target.setId(4);

        authCrawler.setTarget(target);


        MetaCrawler metaCrawler = new MetaCrawler();
        metaCrawler.setId((short)11);

        authCrawler.setCrawler(metaCrawler);

        authCrawler.setAuthJson("{\"DB Name\":\"test\",\"ID\":\"docker\",\"PassWord\":\"qwer5795QWER\"}");


        this.authCrawlerService.regist(authCrawler);

        Assert.assertNotEquals(authCrawler.getId(), 0);

    }

    @Test
    public void findAuth() {

        MetaCrawler metaCrawler = new MetaCrawler();
        metaCrawler.setId((short)23);

        Target target = new Target();
        target.setId(5);


        AuthCrawler authCrawler = this.authCrawlerService.readAuth(metaCrawler, target);

        Assert.assertNotEquals(authCrawler, null);

    }

}