package com.loafle.overflow.module.history.service;

import com.loafle.overflow.commons.model.PageParams;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.history.model.History;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.meta.model.MetaHistoryType;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.spring.AppConfigTest;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.Random;

/**
 * Created by insanity on 17. 8. 23.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class HistoryServiceTest {

    @Autowired
    private HistoryService historyService;

    @Test
    @Ignore
    public void registHistories() {
        Random rand = new Random();
        for (int i=0;i<100;i++) {
            History h = new History();
            h.setMember(new Member(1));
            h.setProbe(new Probe(rand.nextBoolean() ? 1 : 2));
            h.setDomain(new Domain(1));
            h.setType(new MetaHistoryType(rand.nextInt((6 - 1) + 1) + 1));
            h.setMessage("Test History " + i);
            this.historyService.regist(h);
        }
    }


//    @Test
//    @Ignore
//    public void readAllByProbeAndType() {
//        List<History> result = this.historyService.readAllByProbeAndType(new Probe(1), new MetaHistoryType(1));
//        Assert.assertNotNull(result);
//    }

    @Test
    public void readAllByProbe() {
        PageParams p = new PageParams();
        p.setPageNo(0);
        p.setCountPerPage(10);
        p.setSortCol("type.name");
        p.setSortDirection("descending");

        Page<History> result = this.historyService.readAllByProbe(new Probe(1), p);
        for (History h : result.getContent()) {
            System.out.println(h.getId());
        }
        Assert.assertEquals(10, result.getContent().size());
    }

//    @Test
//    @Ignore
//    public void readAllByDomain() {
//        Page<History> result = this.historyService.readAllByDomain(new Domain(1), 0, 10);
//        Assert.assertNotNull(result.getContent());
//    }
}
