package com.loafle.overflow.spring;

import org.codehaus.jackson.map.DeserializationConfig;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.context.annotation.*;
import org.springframework.context.support.PropertySourcesPlaceholderConfigurer;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.test.context.TestPropertySource;

import static org.junit.Assert.*;

/**
 * Created by geek on 17. 8. 8.
 */
@Configuration
@ComponentScan(basePackages = {"com.loafle.overflow"}, excludeFilters = @ComponentScan.Filter({Configuration.class}))
@Import({
        JdbcConfiguration.class,
        MailConfiguration.class,
        RedisConfiguration.class,
        CacheConfiguration.class
})
@TestPropertySource({
        "classpath:database.properties",
        "classpath:mail.properties",
        "classpath:redis.properties",
        "classpath:cache.properties"
})

public class AppConfigTest {

//    @Bean
//    public static PropertyPlaceholderConfigurer propertyPlaceholderConfigurer() {
//        PropertyPlaceholderConfigurer ppc = new PropertyPlaceholderConfigurer();
////        ppc.setLocation(new ClassPathResource("database.properties"));
//        ppc.setLocations(new Resource[] {
//                new ClassPathResource("database.properties"),
//                new ClassPathResource("mail.properties"),
//                new ClassPathResource("redis.properties")
//        });
//        ppc.setIgnoreUnresolvablePlaceholders(true);
//
//        return ppc;
//    }
    @Bean
    public static PropertySourcesPlaceholderConfigurer propertySourcesPlaceholderConfigurer() {
        return new PropertySourcesPlaceholderConfigurer();
    }

    @Bean
    public ObjectMapper getObjectMapper() {

        ObjectMapper objectMapper = new ObjectMapper();

        objectMapper.configure(DeserializationConfig.Feature.FAIL_ON_UNKNOWN_PROPERTIES, false);

        return objectMapper;
    }
}